import { world, system } from "@minecraft/server";
import { useNickTag } from "nickTag";

//replace player name with name tag
world.beforeEvents.chatSend.subscribe((data) => {
    const { sender, message } = data;

    // Extract only the part of nameTag before the first newline (\n)
    let baseName = sender.nameTag.split("\n")[0] || sender.name; 

    if (sender.nameTag !== sender.name) {
        if (sender.nameTag !== "") {
            data.cancel = true;
            world.sendMessage(`${baseName} §r§l§7»§r ${message}`);
        } else {
            data.cancel = true;
            world.sendMessage(`<???> ${message}`);
        }
    }
});
//keep name on leave
world.afterEvents.playerSpawn.subscribe((data) => {
    const { player, initialSpawn } = data;
    if (initialSpawn === true) {
        if (player.getDynamicProperty("savedNameTag")) {
            player.nameTag = player.getDynamicProperty("savedNameTag");
        }
    }
})









//name tag self
world.afterEvents.itemUse.subscribe((data) => {
    const {itemStack, source} = data;
    useNickTag(source, itemStack)
    }
)