import { world, system } from "@minecraft/server";
import { ActionFormData, ModalFormData, MessageFormData } from "@minecraft/server-ui";
import { useItem } from "data";
export function useNickTag(player, itemStack) {
    if (itemStack?.typeId == "tuff:namechanger") {
        useItem(player)
        nickTagForm(player)
    }
}
function createRankSelectionForm() {
const rankSelectionForm = new ActionFormData()
rankSelectionForm.body('Select any Hive rank. If you dont want a rank select No Rank.')
rankSelectionForm.title("§f§lSelect a Rank")
rankSelectionForm.button("§8[§eHive§8]")
rankSelectionForm.button("§8[§3Helper§8]")
rankSelectionForm.button("§8[§dVIP§8]")
rankSelectionForm.button("§8[§cYT§8]")
rankSelectionForm.button("§8[§dStreamer§8]")
rankSelectionForm.button("§8[§dTikTok§8]")
rankSelectionForm.button("§8[§a+§8]")
rankSelectionForm.button("§cNo Rank")
}
function instructions(player) {
    const instructions = new ActionFormData();
    instructions.title("§8How To Use")
    instructions.body("§cTuff Golem's §hNick §dCommand §bVersion §a2.0\n     \n §7- §7§oInput any name you want and it will set your nametag to your desired name. If you dont want your name to be changed then toggle the switch to the left.\n     \n§7 - §oSelect any of the hive server ranks, or make a custom rank with custom colors by selecting custom rank.\n     \n §7- §oResets the nick you gave the target player to their original nametag.\n     \n§7 - §oSelect any of the hive server hub titles, or make a custom hub title by selecting custom hub title. Select no hub title to remove your already existing hub title.\n     \n§7 - §oUse the slider to add a level next to the playerList name, as seen in microhubs and game lobbies. Levels range from 1-100. Put the slider at 0 to remove your level.\n     \n§r§6Need additional help? §7- §oYou can contact me on disord: §bUoq\n     \n§cSubscribe to my Youtube §d@ouk\n     \n§7Glyph assets made by The Hive and Zeqa Network.");
    instructions.button("");
    instructions.show(player).then((data) => {
        if (data.canceled !== true) {
            const result = data.selection;
            if (result === 0) {
                nickTagForm(player)
            }
        }
        })
    }
    function nickTagForm(player) {
        const nickTag = new ActionFormData();
        const playerList = world.getPlayers();
        nickTag.title("");
        nickTag.body("Select a Player, to learn more about this addon click how to use.");
        nickTag.button("How To Use", "font/quest");
        for (let i = 0; i < playerList.length; i++) {
            let rand = Math.floor(Math.random() * 10) + 1; // Generate a unique random number per player
            nickTag.button(`${playerList[i]?.name}\n§7Select Player§r`, `font/gamerpic${rand}`);
        }
        nickTag.show(player).then((data) => {
            if (data.canceled !== true) {
                const result = data.selection;
                if (result === 0) {
                    instructions(player);
                    } else {
                        playerDataForm(player, playerList[result - 1]);
                    }
                }
                });
            }
            function playerDataForm(player, target) {
                const playerData = new ActionFormData();
                playerData.title("")
                playerData.button("", "font/editnick")
                playerData.button("", "font/resetnick")
                playerData.button("", "font/addtitle")
                playerData.button("", "font/addlevel")
                playerData.button("", "font/back")
                playerData.show(player).then((data) => {
                    if (data.canceled !== true) {
                        const result = data.selection;
                        if (result === 0) {
                            editPlayerNameForm(player, target)
                        }
                        if (result === 1) {
                            resetNick(player, target)
                        }
                        if (result === 2) {
                            page3(player, target)
                        }
                        if (result === 3) {
                            numberSelectionForm(player, target);
                        }
                        if (result === 4) {
                            nickTagForm(player)
                        }
                    }
                    })
                }
                function numberSelectionForm(player, target) {
                    const numberForm = new ModalFormData();
                    numberForm.title("");
                    numberForm.slider("§7Select a Level", 0, 100, 1, 0); // Slider from 0 to 100
                    numberForm.submitButton("Submit");
                    numberForm.show(player).then((data) => {
                        if (data.canceled !== true) {
                            const selectedNumber = data.formValues[0];
                            const currentName = target.getDynamicProperty("savedNameTag") || target.name;
                            const cleanName = removeExistingNumber(currentName); // Strip old numbers
                            const styledPlayerName = formatNameWithNumber(cleanName, selectedNumber);
                            let chosenColor = "§7"; // Default (0-9: Light Gray)
                            if (selectedNumber >= 100) chosenColor = "§9";  // 100: Blue
                            else if (selectedNumber >= 80) chosenColor = "§c"; // 80-99: Red
                            else if (selectedNumber >= 50) chosenColor = "§a"; // 50-79: Green
                            else if (selectedNumber >= 30) chosenColor = "§d"; // 30-49: Magenta
                            else if (selectedNumber >= 25) chosenColor = "§b"; // 25-29: Aqua
                            else if (selectedNumber >= 20) chosenColor = "§e"; // 20-24: Yellow
                            else if (selectedNumber >= 10) chosenColor = "§6"; // 10-19: Gold
                            target.nameTag = styledPlayerName;
                            target.setDynamicProperty("savedNameTag", target.nameTag);
                            player.sendMessage(`§a§l» §r§7§o${target.name}§r§7§o's level has been set to ${chosenColor}${selectedNumber}§r§7§o`);
                        }
                        });
                    }
                    // Removes existing number formatting like [10] or [100]
                    function removeExistingNumber(name) {
                        return name.replace(/^§8\[\S+?\] §r/, ""); // Removes brackets and numbers
                    }
                    // Formats the name with the new number
                    function formatNameWithNumber(name, number) {
                        if (number === 0) return name; // No number if 0 is selected
                        let chosenColor = "§7"; // Default (0-9: Light Gray)
                        if (number >= 100) chosenColor = "§9";  // 100: Blue
                        else if (number >= 80) chosenColor = "§c"; // 80-99: Red
                        else if (number >= 50) chosenColor = "§a"; // 50-79: Green
                        else if (number >= 30) chosenColor = "§d"; // 30-49: Magenta
                        else if (number >= 25) chosenColor = "§b"; // 25-29: Aqua
                        else if (number >= 20) chosenColor = "§e"; // 20-24: Yellow
                        else if (number >= 10) chosenColor = "§6"; // 10-19: Gold
                        return `§8[${chosenColor}${number}§8] §r${name}`;
                    }
                    function resetNick(player, target) {
                        const resetConfirmation = new MessageFormData()
                        .title("§8Confirm Nick Reset")
                        .body(`Are you sure you want to reset ${target.name}'s nickname to default?`)
                        .button2("§aYes, Reset")
                        .button1("§cCancel");
                        resetConfirmation.show(player).then((data) => {
                            if (data.selection === 1) { // If player confirms
                            target.nameTag = target.name;
                            target.setDynamicProperty("savedNameTag", undefined);
                            player.sendMessage(`§a§l» §r§7§o${target.name}'s name has been reset to default.`);
                            } else { // If player cancels
                            player.sendMessage("§c§l» §r§cNickname reset canceled.");
                        }
                        });
                    }
                    function editPlayerNameForm(player, target) {
                        const editPlayerName = new ModalFormData();
                        editPlayerName.title("")
                        editPlayerName.textField("", "§7Name")
                        editPlayerName.toggle("Nick Enabled", true)
                        editPlayerName.submitButton("Submit")
                        editPlayerName.show(player).then((data) => {
                            if (data.canceled !== true) {
                                const result = data.formValues;
                                page2(target, player)
                                if (result[1] === true) {
                                    target.nameTag = result[0];
                                    target.setDynamicProperty("savedNameTag", result[0])
                                }
                                else
                                target.nameTag = target.name
                            }
                        })}
                        function customForm(player, target) {
                            if (!target) {
                                player.sendMessage("§cError: No player selected!");
                                return;
                            }
                            const custom = new ModalFormData();
                            custom.title("");
                            custom.textField("Enter a Custom Rank Name", "e.g., Legend");
                            custom.dropdown("Select Rank Color", [
                            "§rNo Color", "§0Black", "§1Dark Blue", "§2Dark Green", "§3Dark Aqua",
                            "§4Dark Red", "§5Dark Purple", "§6Gold", "§7Gray", "§8Dark Gray",
                            "§9Blue", "§aGreen", "§bAqua", "§cRed", "§dLight Purple", "§eYellow",
                            "§fWhite", "§hPink", "§iViolet", "§jSky Blue", "§mSpring Blue",
                            "§nLime", "§pPear", "§qTan", "§sEmber", "§tCoral Red", "§uLight Grey"
                            ]);
                            custom.submitButton("Confirm");
                            custom.show(player).then((data) => {
                                if (data.canceled !== true) {
                                    const result = data.formValues;
                                    const customRank = result[0].trim();
                                    const chosenColorCodes = [
                                    "", "§0", "§1", "§2", "§3", "§4", "§5", "§6",
                                    "§7", "§8", "§9", "§a", "§b", "§c", "§d",
                                    "§e", "§f", "§h", "§i", "§j", "§m", "§n", "§p",
                                    "§q", "§s", "§t", "§u"
                                    ];
                                    const chosenColor = chosenColorCodes[result[1]];
                                    if (customRank.length > 0) {
                                        // Ensure target has a nameTag before modifying it
                                        const baseName = target.nameTag || target.name;
                                        target.nameTag = `${chosenColor}${baseName} §8[${chosenColor}${customRank}§8]`;
                                        target.setDynamicProperty("savedNameTag", target.nameTag);
                                        player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                        } else {
                                            player.sendMessage("§c§l» §r§cInvalid rank name! Please enter a valid rank.");
                                        }
                                    }
                                    });
                                }
                                function page2(target, player) {
                                    const page2 = new ActionFormData();
                                    page2.body('Select any §eHive§r rank. If you dont want a rank select §cNo Rank§r.')
                                    page2.title("§l§8Select a Rank")
                                    page2.button("§8[§eOwner§8]")
                                    page2.button("§8[§eHive§8]")
                                    page2.button("§8[§3Helper§8]")
                                    page2.button("§8[§dVIP§8]")
                                    page2.button("§8[§cYT§8]")
                                    page2.button("§8[§dStreamer§8]")
                                    page2.button("§8[§dTikTok§8]")
                                    page2.button("§8[§a+§8]")
                                    page2.button("§l§aCustom Rank")
                                    page2.button("§l§cNo Rank §8(§7Gray§8)")
                                    page2.button("")
                                    page2.show(player).then((data) => {
                                        if (data.canceled !== true) {
                                            const selection = data.selection;
                                            if (selection === 0) {
                                                target.nameTag = (`§e${target.nameTag} §8[§eOwner§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 1) {
                                                target.nameTag = (`§e${target.nameTag} §8[§eHive§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 2) {
                                                target.nameTag = (`§3${target.nameTag} §8[§3Helper§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 3) {
                                                target.nameTag = (`§d${target.nameTag} §8[§dVIP§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 4) {
                                                target.nameTag = (`§c${target.nameTag} §8[§cYT§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 5) {
                                                target.nameTag = (`§d${target.nameTag} §8[§dStreamer§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 6) {
                                                target.nameTag = (`§d${target.nameTag} §8[§dTikTok§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 7) {
                                                target.nameTag = (`§a${target.nameTag} §8[§a+§8]`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 8) {
                                                customForm(player, target)
                                            }
                                            if (selection === 9) {
                                                target.nameTag = (`§7${target.nameTag}`)
                                                target.setDynamicProperty("savedNameTag", target.nameTag)
                                                player.sendMessage(`§a§l» §r§7§oApplied custom name '${target.nameTag}§r§7§o' to ${target.name}.`);
                                            }
                                            if (selection === 10) {
                                                editPlayerNameForm(player, target);
                                            }
                                        }
                                    })}
                                    function hubDisplayTitleMenu(player, target) {
                                        if (!target) {
                                            player.sendMessage("§cError: No player selected!");
                                            return;
                                        }
                                        const hubDisplayTitle = new ActionFormData();
                                        hubDisplayTitle.title("");
                                        hubDisplayTitle.body("Select a Hub Title or enter a custom one.");
                                        hubDisplayTitle.button("§l§cNo Hub Title");
                                        hubDisplayTitle.button("§l§aCustom Hub Title");
                                        const titles = [
                                        "§cBuz§6zta§esti§ac Cr§bea§dtor ",
                                        "§eTranslator ",
                                        "§e1000 Day Login Streak ",
                                        "§fThe §6Ship§ewri§bght ",
                                        "§6Leg§eend§fary §6Shi§epwr§fight ",
                                        "§hBeeday §jBuilder ",
                                        "§tCa§ske §qCo§nnn§moi§jss§ieu§hr ",
                                        "§fSnowflake §jSculptor ",
                                        "§fSn§bow§jma§fn M§bae§jst§fro ",
                                        "§fBrrr§bill§3iant §fArt§bist ",
                                        "§aOr§bbi§ata§bl I§all§bus§atr§bat§aor ",
                                        "§6Park§eour Pic§basso ",
                                        "§6Award §eWinning §bDirector ",
                                        "§dDi§bsc§do D§byn§dam§bo ",
                                        "§fDa§ence§6flo§cor §dHe§9ro ",
                                        "§fMo§pvi§2e M§fav§per§2ic§2k ",
                                        "§mSpo§foky §mSto§fry§mtell§fer ",
                                        "§fHap§epy b§6eed§cay! ",
                                        "§cHa§6pp§ey B§aee§bda§dy! ",
                                        "§fHa§bpp§3y B§fee§bda§3y! ",
                                        "§fHa§ppp§2y B§fee§pda§2y! ",
                                        "§bMurder §dMystery ",
                                        "§eMur§6der §eMyst§6ery ",
                                        "§3Mur§bder §3Myst§bery ",
                                        "§aMur§2der §aMyst§2ery ",
                                        "§fMu§erd§6er §cMy§dste§9ry ",
                                        "§jSky 50.1K Kills",
                                        "§jSky 1000 Victories",
                                        "§eSG 50.1K Kills",
                                        "§eSG 1000 Victories",
                                        "§eSG 100.00 K/D Ratio",
                                        "§e1 Year §6TW §bVeteran ",
                                        "§e2 Year §6TW §bVeteran ",
                                        "§e3 Year §6TW §bVeteran ",
                                        "§e4 Year §6TW §bVeteran ",
                                        "§e5 Year §6TW §bVeteran ",
                                        "§bTreasure §aWars ",
                                        "§eTre§6asu§ere §eW§6ars ",
                                        "§3Tre§basu§3re §3W§bars ",
                                        "§aTre§2asu§are §aW§2ars ",
                                        "§fTr§eea§6su§cre §dWa§9rs ",
                                        "§fTr§eea§6su§cre §dWa§9rs §fLvl §e600 ",
                                        " §414000 Victories",
                                        " §430000 Final Kills",
                                        " §c12345 Beds Destroyed",
                                        " §t100%% Winrate",
                                        " §t100.00 K/D Ratio",
                                        " §tBedWars Season 1",
                                        " §tSeason 1 §6Top 100",
                                        " §tSeason 1 §6Top 1k",
                                        " §tSeason 1 §6Top 10k",
                                        " §tSeason 1 §6Top 100k",
                                        " §tSeason 1 §6#1"
                                        ];
                                        titles.forEach(title => hubDisplayTitle.button(title));
                                        hubDisplayTitle.show(player).then((data) => {
                                            if (data.canceled !== true) {
                                                const result = data.selection;
                                                const baseName = target.nameTag.split("\n")[0]; // Keep only the first line (ranked name)
                                                if (result === 0) {
                                                    // Remove hub title, only keep the rank
                                                    target.nameTag = baseName;
                                                    target.setDynamicProperty("savedNameTag", target.nameTag);
                                                    player.sendMessage(`§a§l» §r§7§o${target.name}'s hub title has been reset to default.`);
                                                    } else if (result === 1) {
                                                        customHubTitleForm(player, target);
                                                        } else {
                                                            // Apply selected hub title to the target
                                                            target.nameTag = `${baseName}\n${titles[result - 2]}`;
                                                            target.setDynamicProperty("savedNameTag", target.nameTag);
                                                            player.sendMessage(`§a§l» §r§7§oApplied hub title '${titles[result - 2]}§r§7§o' to ${target.name}.`);
                                                        }
                                                    }
                                                    });
                                                }
                                                function customHubTitleForm(player, target) {
                                                    const customHub = new ModalFormData();
                                                    customHub.title("");
                                                    customHub.textField("Enter a Custom Hub Title", "e.g., Champion");
                                                    customHub.submitButton("Confirm");
                                                    customHub.show(player).then((data) => {
                                                        if (data.canceled !== true) {
                                                            const customTitle = data.formValues[0].trim();
                                                            const baseName = target.nameTag.split("\n")[0]; // Keep only the first line (ranked name)
                                                            if (customTitle.length > 0) {
                                                                // Apply custom hub title to the target
                                                                target.nameTag = `${baseName}\n${customTitle}`;
                                                                target.setDynamicProperty("savedNameTag", target.nameTag);
                                                                player.sendMessage(`§a§l» §r§7§oApplied custom hub title '${customTitle}§r§7§o' to ${target.name}.`);
                                                                } else {
                                                                    player.sendMessage("§c§l» §r§cInvalid hub title! Please enter a valid title.");
                                                                }
                                                            }
                                                            });
                                                        }
                                                        function page3(player, target) {
                                                            hubDisplayTitleMenu(player, target);
                                                        }